unit Unit1;

{ events
  game control
}   

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, xbitmap_unit,shellApi;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Label1: TLabel;
    Timer1: TTimer;
    PaintBox3: TPaintBox;
    infotext: TStaticText;
    Image1: TImage;
    StaticText1: TStaticText;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PaintBox3Paint(Sender: TObject);
    procedure PaintBox3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label2MouseEnter(Sender: TObject);
    procedure Label2MouseLeave(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  map1,map2,map3 : TXbitmap;
  roq : TXbitmap;
  goatmap : array[1..6] of Tbitmap;

implementation

{$R *.dfm}

uses draw_unit;

type Tgamestate = (gsInit,gsPlay,gsJumping,gsEnd);
     Tgoattype = (gtNone,gtRight,gtLeft);//goat type
     Tmsg = (msgInitDone,msgBtnPressed,msgJump,msgJumpDone);
     Tleglength = (longleg,shortleg);
     TjumpTrace = record
                   goatNr : byte;
                   x,y : integer;
                   leftleg : Tleglength;
                   rightleg : Tleglength;
                  end;
     TGoatcoord = record
                   x1,y1,x2,y2 : integer;//rectangle of goat on platform
                  end;
     Tgame = record
              goattype : Tgoattype;
              roq : byte;
             end;

     TGoatBias = record               //position corrections per goat
                  x : shortInt;       //relative to roq
                  y : shortInt;
                 end;

     Tgoatleg = record
                 x1,y1: integer;
                 x2,y2: integer;
                end;

const goatbias : array[1..6] of Tgoatbias =   //relative to roq coord.
                 ((x:20; y: 0),
                  (x:20; y: 0),
                  (x:20; y: 0),
                  (x: 5; y: 0),
                  (x: 5; y: 0),
                  (x: 5; y: 0));

     goatlegCoord : array[1..6] of Tgoatleg =        //leg positions
                  ((x1:13; y1:50; x2:45; y2:50),     //relative to (left,top)
                   (x1:20; y1:60; x2:50; y2:50),     //for all goat types
                   (x1:12; y1:35; x2:40; y2:52),
                   (x1:35; y1:50; x2:65; y2:50),
                   (x1:42; y1:52; x2:70; y2:35),
                   (x1:30; y1:48; x2:57; y2:62));

     goatlegcolor = $304060;

var map1rect,map2rect,map3rect : Trect;
    map1full,map2full,map3full : boolean;

    level : byte;
    game : array[1..9] of Tgame;//goattype on physical platform
    gamestate : TGamestate;
    goatCoord : array[1..9] of TgoatCoord;

    jumptrace : array[1..10] of Tjumptrace;//goattype = 0: table end
    selGoat : byte;  //selected goat
    emptyroq: byte;  //logical empty location
    maxRoq : byte;
    timercount : byte;
    jumprect : Trect;
    jumpBias : TPoint; //parabola relative to this point

    btnstate : byte;//0: inactive; 1:active
    bonus : byte;   //bonuscount for won games
    btntext : string;

procedure gamecontrol(msg : Tmsg);forward
procedure GoJump;forward;

//--- decoration ---

procedure drawEdge(pb : Tpaintbox; clr1 : DWORD; clr2 : DWORD; w : byte);
//edge on form1 around paintbox1
var x1,y1,x2,y2 : integer;
    i : byte;
begin
 with pb do
  begin
   x1 := left - w;
   y1 := top - w;
   x2 := left + width - 1 + w;
   y2 := top + height - 1 + w;
  end;
 with form1.Canvas do
  begin
   pen.Width := 1;
   for i := 0 to w-1 do
    begin
     pen.Color := clr1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := clr2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

//--- map updates ---

procedure updatemap2(var r :Trect);
begin
 if map2full then map2rect := unirect(map2rect,r)
  else begin
        map2full := true;
        map2rect := r;
       end;
end;

procedure updatemap3(var r :Trect);
begin
 if map3full then map3rect := unirect(map3rect,r)
  else begin
        map3full := true;
        map3rect := r;
       end;
end;

procedure copymap12;
begin
 if map1full = false then exit;
 map2.Canvas.CopyRect(map1rect,map1.Canvas,map1rect);
 updatemap2(map1rect);
 map1full := false;
end;

procedure copymap23;
begin
 if map2full = false then exit;
 map3.Canvas.CopyRect(map2rect,map2.Canvas,map2rect);
 updatemap3(map2rect);
 map2full := false;
end;

procedure copymap3tobox;
begin
 if map3full = false then exit;
 form1.PaintBox1.Canvas.CopyRect(map3rect,map3.Canvas,map3rect);
 map3full := false;
end;

//--- draw goat & legs ---

function getGoatrect(n : byte; gt : Tgoattype) : Trect;
//supply rectangle of logical position dest for goat at pos org
var g,m : byte;
begin
 m := game[n].roq; //get physical roq
 if gt = gtRight then g := 1 else g := 4;//goat type
 with result do
  begin
   left := goatcoord[m].x1 + goatbias[g].x;
   top := goatcoord[m].y1 + goatbias[g].y;
   right := left + goatmap[g].Width;
   bottom := top + goatmap[g].Height + 30;//include legs
  end;
end;

procedure drawGoatlegs(bm:TXbitmap; n : byte; x,y:integer;
                      leftlength,rightlength:Tleglength);
//--length = (longleg,shortleg)
//paint in bm at position (x,y) + (goatlegCoord[n].x,y
var dx,dy :integer;
    x1,y1 : integer;
begin
 with bm do
  begin
   xpenwidth := 5;
   xpencolor := goatlegcolor;
   xpenlevel := 0;
   case leftlength of
    longleg  : begin
                dx :=  7;
                dy := 18;
               end;
    shortleg : begin
                dx := 17;
                dy :=  9;
               end;
   end;//case
   x1 := x + goatlegCoord[n].x1;
   y1 := y + goatlegCoord[n].y1;
   xline(x1,y1,x1-dx,y1+dy);
   xline(x1-dx,y1+dy,x1,y1+2*dy);
   case rightlength of
    longleg  : begin
                dx :=  7;
                dy := 18;
               end;
    shortleg : begin
                dx := 17;
                dy :=  9;
               end;
   end;//case
   x1 := x + goatlegCoord[n].x2;
   y1 := y + goatlegCoord[n].y2;
   xline(x1,y1,x1+dx,y1+dy);
   xline(x1+dx,y1+dy,x1,y1+2*dy);
  end;
end;

procedure showGoat(n : byte);
//goattype allready in game[n].goattype
//show logical goat in map2 with long legs
//update map2
var r : Trect;
begin
 r := getGoatRect(n,game[n].goattype);
 case game[n].goattype of
  gtleft : n := 4;   //n : goat nr
  gtright : n:= 1;
 end;//case
 updatemap2(r);
 map2.Canvas.Draw(r.left,r.top,goatmap[n]);
 drawgoatlegs(map2,n,r.Left,r.top,longleg,longleg);
end;

procedure removeGoat(n : byte);
//remove (logical) goat n from game
//update map2rect
var m : byte;
begin
 if game[n].goattype = gtRight then m := 1 else m := 4;//goat type
 map1rect := getGoatRect(n,game[n].goattype);
 map1full := true;
 copymap12;
end;

procedure copyGoat(x,y : integer; n : byte);
//copy picture of goat n at (x,y) in map3
//updata map3rect
var r : Trect;
begin
 map3.Canvas.Draw(x,y,goatmap[n]);
 r.Left := x;
 r.Right := x+80;
 r.top := y;
 r.Bottom := y + 110;//include legs
 updatemap3(r);
end;

//--- game control ---

procedure initlevel;
//initialize level {1..3] of game
var i : byte;
    roqX,roqY : integer;
begin
 form1.Invalidate;//to repaint roq numbers
 gamestate := gsInit;
 btnstate := 0;//inactive
 form1.PaintBox2.Invalidate;//repaint level

 for i := 1 to 9 do
  with goatCoord[i] do        //set roq rectangles
   begin
    x1 := i*100 - 80;
    x2 := x1 + 80;
    y2 := getRoqY(i);
    y1 := y2 - 80;
   end;

 for i := 1 to 9 do
  with game[i] do           //clear game
   begin
    goattype := gtNone;
    roq := 0;
   end;

 maxRoq := 2*level + 3;     //reset goats in game
 for i := 1 to level+1 do
  with game[i] do
   begin
    goattype := gtRight;
    roq := i + 3 - level;
   end;
 game[level+2].roq := 5;
 for i := level+3 to 2*level+3 do
  with game[i] do
   begin
    goattype := gtLeft;
    roq := i + 3 - level;
   end;

 makemap1;
 for i := 1 to maxRoq do        //place roqs on map1,2
  begin
   roqX := game[i].roq*100 - 80;
   roqY := getRoqY(game[i].roq);
   map1.Canvas.Draw(roqX,RoqY,roq);
  end;

 with map1 do map1rect := rect(0,0,width,height);
 map1full := true;
 copymap12;

 for i := 1 to maxRoq do        //place goats on map2
  with game[i] do if goattype <> gtNone then showGoat(i);

 copymap23;
 form1.PaintBox1.Invalidate;
 emptyroq := level + 2;
 gamecontrol(msgInitdone);
end;

//--- events ---

procedure TForm1.FormCreate(Sender: TObject);
var i : byte;
begin
 level := 1;
 infotext.Caption := 'welcome...!';
 bonus := 0;
 map1 := TXbitmap.create;  //create map1
 with map1 do
  begin
   width := 940;
   height := 400;
   map1full := false;
  end;
 map2 := TXbitmap.create;  //create map2
 with map2 do
  begin
   width := 940;
   height := 400;
   map2full := false;
  end;
  map3 := TXbitmap.create;  //create map3
 with map3 do
  begin
   width := 940;
   height := 400;
   map3full := false;
  end;
 roq := TXbitmap.create;    //create roq map
 with roq do
  begin
   width := 100;
   height := 150;
  end;
  for i := 1 to 6 do       //create goat maps
  begin
   goatmap[i] := Tbitmap.Create;
   with goatmap[i] do
    begin
     width := 80;
     height := 80;
     pixelformat := pf32bit;
    end;
  end;

 makeroq;
 makeAllGoats;
 form1.Timer1.Interval := 100;//====
 initlevel; //==
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i : byte;
begin
 for i := 1 to 6 do goatmap[i].Free;
 roq.Free;
 map1.Free;
 map2.Free;
 map3.Free;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with map3 do
  begin
   map3rect := rect(0,0,width,height);
  end;
 map3full := true;
 copymap3tobox;

//== testdraw;
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
var x, y : integer;
    s : string;
begin
 with paintbox2 do with canvas do
  begin
   brush.Color := $e0ffff;
   brush.Style := bssolid;
   fillrect(rect(0,0,width,height));
   brush.Style := bsClear;
   font.Name := 'arial';
   font.Height := height;
   font.Style := [fsbold];
   s := inttostr(level);
   x := (width - textwidth(s)) div 2;
   y := (height - textheight(s)) div 2;
   font.Color := $ffa000;
   textout(x+2,y+2,s);
   font.color := $e00000;
   textout(x,y,s);
  end;
end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
//right bottom button
//btnstate : 0 inactive, 1 active
type TactionBtn = record
                   topcol : DWORD;
                   downcol: DWORD;
                   background : DWORD;
                  end;
const Btnprops : array[0..1] of TactionBtn =
             ((topcol : $ff0000; downcol: $800000; background : $c0c0ff),
              (topcol : $800000; downcol: $ffa000; background : $7070d0));
var i : byte;
    x,y : integer;
begin
 with paintbox3 do with canvas do
  begin
   font.Name := 'arial';
   font.Size := trunc(0.4*height);
   brush.color := btnProps[btnstate].background;
   brush.style := bssolid;
   fillrect(rect(0,0,width,height));
   pen.width := 1;
   for i := 0 to 3 do
    begin
     pen.color := btnprops[btnstate].topcol;
     moveto(width-1-i,i);
     lineto(i,i);
     lineto(i,height-1-i);
     pen.color := btnprops[btnstate].downcol;
     lineto(width-1-i,height-1-i);
     lineto(width-1-i,i);
    end;
   case btnstate of
    0 : font.Style := [fsBold];
    1 : font.Style := [];
   end;
   x := (width - textwidth(btntext)) div 2;
   y := (height - textheight(btntext)) div 2;
   brush.Style := bsClear;
   textout(x,y,btntext);
  end;//with paintbox
end;

procedure TForm1.FormPaint(Sender: TObject);
var y : integer;
    i : byte;
begin
 drawEdge(paintbox1,$000000,$c0c0c0,3);
 drawedge(paintbox2,$e00000,$ff8000,4);
 drawedge(paintbox3,$ffffff,$000000,2);
 with canvas do
  begin
   font.Name := 'arial';
   font.Style := [];
   font.height := 16;
   font.color := $808080;
   brush.Style := bsclear;
   textout(20,10,'rules:');
   font.Color := $000000;
   textout(20,25,'Goats may jump forward one or two places');
   textout(20,40,'to next empty place');
   textout(20,55,'Puzzle is solved if goats have changed place.');
   y := paintbox1.Top + paintbox1.Height;
   textout(20,y+25,'click on goat that must jump');
   textout(20,y+40,'or enter number');
   textout(20,y+55,'press <RETURN> or <SPACE> for button');
   font.Style := [fsBold];
   font.Color := $808080;
   for i := 1 to maxroq do textout(280+100*(i-level),y+5,inttostr(i));
  end;
end;

//--- jump support ---

procedure jump1Right;
//jump from selgoat to emptyroq
const jumpdata : array[1..5] of Tjumptrace =
               ((goatNr:2; x:0; y:0;  leftleg:shortleg; rightleg:longleg),
                (goatNr:2; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:1; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:3; x:0; y:0;  leftleg: shortleg; rightleg:longleg),
                (goatNr:3; x:0; y:0;  leftleg: longleg; rightleg:longleg));

var a,b : single;                //y=ax^2 + bx
    x1,y1,x2,y2,xx,h : integer;
    r : Trect;
    i : byte;
begin
 r := getGoatRect(emptyroq,gtRight);
 x1 := jumprect.Left;
 y1 := jumprect.Top;
 x2 := r.Left-x1;
 y2 := y1 - r.Top;
 if y2 >= 0 then h := y2 + 25 else h := 25;//h:height of jump
 jumpbias.X := x1;
 jumpbias.Y := y1;
 b := 0.02*(h + sqrt(h*h - y2*h));
 a := -b*b/(4*h);
 for i := 1 to 5 do
  with jumptrace[i] do
   begin
    xx := trunc(0.25*x2*(i-1));//jump in 4 steps
    x := jumpbias.X + xx;
    y := jumpbias.Y - trunc(a*xx*xx + b*xx);
    goatNr := jumpdata[i].goatNr;
    leftleg := jumpdata[i].leftleg;
    rightleg := jumpdata[i].rightleg;
   end;
end;

procedure jump1Left;
//jump from selgoat to emptyroq
const jumpdata : array[1..5] of Tjumptrace =
               ((goatNr:6; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:6; x:0; y:0;  leftleg: longleg; rightleg:longleg),
                (goatNr:4; x:0; y:0;  leftleg:shortleg; rightleg:shortleg),
                (goatNr:5; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:5; x:0; y:0;  leftleg: longleg; rightleg:longleg));

var a,b : single;                //y=ax^2 + bx
    x1,y1,x2,y2,xx,h : integer;
    r : Trect;
    i : byte;
begin
 r := getGoatRect(emptyroq,gtRight);
 x1 := jumprect.Left;
 y1 := jumprect.Top;
 x2 := r.Left-x1;
 y2 := y1 - r.Top;
 if y2 >= 0 then h := y2 + 25 else h := 25;//h:height of jump
 jumpbias.X := x1;
 jumpbias.Y := y1;
 b := -0.02*(h + sqrt(h*h - y2*h));
 a := -b*b/(4*h);
 for i := 1 to 5 do
  with jumptrace[i] do
   begin
    xx := trunc(0.25*x2*(i-1));//jump in 4 steps
    x := jumpbias.X + xx;
    y := jumpbias.Y - trunc(a*xx*xx + b*xx);
    goatNr := jumpdata[i].goatNr;
    leftleg := jumpdata[i].leftleg;
    rightleg := jumpdata[i].rightleg;
   end;
end;

procedure jump2Right;
const jumpdata : array[1..9] of Tjumptrace =
               ((goatNr:2; x:0; y:0;  leftleg:shortleg; rightleg:longleg),
                (goatNr:2; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:1; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:1; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:1; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:1; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:3; x:0; y:0;  leftleg: shortleg; rightleg:longleg),
                (goatNr:3; x:0; y:0;  leftleg: longleg; rightleg:longleg),
                (goatNr:3; x:0; y:0;  leftleg: longleg; rightleg:shortleg));
var a,b : single;
    x1,y1,x2,y2,xx,h : integer;
    r : Trect;
    i : byte;
begin
 r := getGoatRect(emptyroq,gtRight);
 x1 := jumprect.Left;
 y1 := jumprect.Top;
 x2 := r.Left-x1;
 y2 := y1 - r.Top;
 if y2 >= 0 then h := y2 + 80 else h := 80;//h:height of jump
 jumpbias.X := x1;
 jumpbias.Y := y1;
 b := 0.01*(h + sqrt(h*h - y2*h));
 a := -b*b/(4*h);
 for i := 1 to 9 do
  with jumptrace[i] do
   begin
    xx := trunc(0.125*x2*(i-1));//jump in 4 steps
    x := jumpbias.X + xx;
    y := jumpbias.Y - trunc(a*xx*xx + b*xx);
    goatNr := jumpdata[i].goatNr;
    leftleg := jumpdata[i].leftleg;
    rightleg := jumpdata[i].rightleg;
   end;
end;

procedure jump2Left;
const jumpdata : array[1..9] of Tjumptrace =
               ((goatNr:6; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:6; x:0; y:0;  leftleg: longleg; rightleg: longleg),
                (goatNr:4; x:0; y:0;  leftleg: shortleg; rightleg:longleg),
                (goatNr:4; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:4; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:4; x:0; y:0;  leftleg: shortleg; rightleg:shortleg),
                (goatNr:5; x:0; y:0;  leftleg: longleg; rightleg:shortleg),
                (goatNr:5; x:0; y:0;  leftleg: longleg; rightleg:longleg),
                (goatNr:5; x:0; y:0;  leftleg: shortleg; rightleg:longleg));
var a,b : single;
    x1,y1,x2,y2,xx,h : integer;
    r : Trect;
    i : byte;
begin
 r := getGoatRect(emptyroq,gtRight);
 x1 := jumprect.Left;
 y1 := jumprect.Top;
 x2 := r.Left-x1;
 y2 := y1 - r.Top;
 if y2 >= 0 then h := y2 + 80 else h := 80;//h:height of jump
 jumpbias.X := x1;
 jumpbias.Y := y1;
 b := -0.01*(h + sqrt(h*h - y2*h));
 a := -b*b/(4*h);
 for i := 1 to 9 do
  with jumptrace[i] do
   begin
    xx := trunc(0.125*x2*(i-1));//jump in 4 steps
    x := jumpbias.X + xx;
    y := jumpbias.Y - trunc(a*xx*xx + b*xx);
    goatNr := jumpdata[i].goatNr;
    leftleg := jumpdata[i].leftleg;
    rightleg := jumpdata[i].rightleg;
   end;
end;

procedure GoJump;
var d : shortInt;
    i : byte;
begin
 timercount := 0;
 jumprect := getGoatrect(selgoat,game[selgoat].goattype);
 d := emptyroq - selgoat;
 for i := 1 to 10 do jumptrace[i].goatNr := 0;
 case d of
  1 : jump1right;
  2 : jump2Right;
  -1: jump1left;
  -2: jump2left;
 end;
 removegoat(selgoat);
 copymap23;
 form1.Timer1.Enabled := true;
end;

procedure finishjump;
//show goat, update game
begin
 updatemap2(jumprect);
 game[emptyroq].goattype := game[selgoat].goattype;
 showgoat(emptyroq);
 game[selgoat].goattype := gtNone;//remove
 emptyroq := selgoat;
 selgoat := 0;
 copymap23;
 copymap3tobox;
end;

function canJump(x,y : integer) : byte;
//test screen coords (x,y) for selected goat that can jump
//return 0 if no jump possible
//return nr of goat if jump possible
var i : byte;
    d : shortInt;
    r : Trect;
begin
 i := 0;
 result := 0;
 repeat
  inc(i);
  if i <> emptyroq then
   begin
    r := getGoatRect(i,game[i].goattype);
    if (x-10 > r.left) and (x+10 < r.Right) and
       (y-20 > r.top) and (y+30 < r.Bottom) then
     begin
      d := emptyroq - i;
      if (game[i].goattype = gtRight) then
       begin                                //right jump
        if (d=1) or (d=2) then
         begin
          result := i;
          i := maxroq;//terminate
         end;
       end
      else                                 //left jump
       if (d= -1) or (d= -2) then
        begin
         result := i;
         i := maxRoq;//terminate
        end;
     end;
   end;
 until (i = maxRoq);
end;

//--- mouse events ---

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//mouse move in game
var selGoat2: byte;
begin
 if gamestate <> gsPlay then exit;

 selgoat2 := CanJump(x,y);
 if selgoat2 <> selgoat then
  begin
   if selgoat2 <> 0 then paintbox1.Cursor := crHandpoint
    else paintbox1.Cursor := crArrow;
  end;
 selgoat := selgoat2;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//mouse down in game
begin
 if gamestate <> gsPlay then exit;
 paintbox1.Cursor := crArrow;
 if selgoat <> 0 then gamecontrol(msgJump);
end;

//--- timer ---

procedure TForm1.Timer1Timer(Sender: TObject);
//execute jumptrace
var r : Trect;
begin
 inc(timercount);
 with jumptrace[timercount] do
  begin
   if goatNr = 0 then
    begin
     timer1.Enabled := false;
     gameControl(msgJumpDone);
    end
    else
     begin
      updatemap2(jumprect);
      copymap23;
      copygoat(x,y,goatNr);
      drawgoatlegs(map3,goatNr,x,y,leftleg,rightleg);
      copymap3tobox;
      jumprect := rect(x-10,y,x+90,y+110); //include legs
     end;
  end;
end;

procedure TForm1.PaintBox3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (gamestate = gsEnd) or (gamestate = gsPlay) then
  begin
   btnstate := 1;
   paintbox3.Invalidate;
  end; 
end;

procedure TForm1.PaintBox3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if btnstate = 1 then gamecontrol(msgBtnPressed);
 btnstate:= 0;
 paintbox3.Invalidate;
end;

//--- game control ---

procedure setBtntext(s : string);
begin
 btntext := s;
 form1.paintbox3.invalidate;
end;

function solved : boolean;
//return true if puzzle is solved
var i : byte;
    count : byte;
begin
 count := 0;
 for i := 1 to level + 1 do
  begin
   if game[i].goattype = gtLeft then inc(count);
   if game[maxroq-i+1].goattype = gtRight then inc(count);
  end;
 result := count = maxroq-1;
end;

procedure gamecontrol(msg : Tmsg);
//update settings, provide info to player
//called by end of initialize, action button pressed, jump, jump done
begin
 case gamestate of
     gsInit : if msg = msgInitDone then
               begin
                setBtntext('restart');
                gamestate := gsPlay;
                selgoat := 0;         //no goat selected
               end;
     gsPlay : case msg of
               msgJump : begin
                          form1.infotext.caption := '';
                          gamestate := gsJumping;
                          GoJump;
                         end;
               msgBtnPressed : begin
                                if (bonus = 0) and (level > 1) then
                                  dec(level);
                                if bonus > 0 then dec(bonus);  
                                initlevel;
                               end;
              end;
  gsJumping : if msg = msgJumpDone then
               begin
                finishjump;
                if solved then
                 begin
                  gamestate := gsEnd;
                  inc(bonus,level);
                  if bonus > 3 then bonus := 3;
                  form1.infotext.caption := 'congratulations !  level '+
                        inttostr(level)+ ' (of 3) solved';
                  if level < 3 then setBtntext('level '+inttostr(level+1));
                 end
                 else gamestate := gsPlay;
               end;
     gsEnd  : if msg = msgBtnPressed then
               begin
                form1.infotext.caption := '';
                if level < 3 then inc(level);
                initlevel;
               end;
 end;//case
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
//only 1..maxroq allowed
var n : byte;
    d : shortInt;
begin
 if (gamestate = gsplay) or (gamestate = gsEnd) then
  if (key = #13) or (key = #32) then
   begin
    gamecontrol(msgBtnPressed);
    exit;
   end;

 if gamestate <> gsPlay then exit;
 n := byte(key);
 if (n > ord('0')) and (n <= ord('0') + maxroq) then //if n in range
  begin
   n := n - ord('0');
   d := emptyroq - n;
   if ((game[n].goattype = gtRight) and ((d=1) or (d=2))) or
      ((game[n].goattype = gtLeft) and ((d= -1) or (d= -2))) then
     begin
      selgoat:= n;
      gamecontrol(msgJump);
     end;
  end;
end;

//davdata link

procedure TForm1.Label2MouseEnter(Sender: TObject);
begin
 with label2 do
  begin
   Font.Color := $0000ff;
   font.Style := [fsUnderline];
  end;
end;

procedure TForm1.Label2MouseLeave(Sender: TObject);
begin
 with label2 do
  begin
   Font.Color := $ff0000;
   font.Style := [];
  end;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 shellexecute(handle,'open',Pchar('http://www.davdata.nl/'),nil,nil,SW_SHOW);
end;

end.
