unit draw_unit;

{ drawings }

interface

uses windows,types;

type Tgpoint = record
                x,y : byte;
               end;
       Tgoat = array[1..36] of Tgpoint;
       Troqplane = record
        x : byte;
        y : byte;
        color : DWORD;
       end;

procedure makeMap1;
procedure makeroq;
procedure makeAllGoats;
function getRoqY(n : byte) : integer;
procedure testdraw;      //debug

implementation

uses unit1,xbitmap_unit;

const goatdata : Tgoat =
             ((x :  30; y : 135),  //A
              (x : 120; y : 135),  //B
              (x : 120; y :  85),  //C
              (x :  30; y :  85),  //D
              (x : 155; y :  85),  //E
              (x : 155; y :  55),  //F
              (x : 120; y :  55),  //G
              (x :  30; y :  95),  //H
              (x :  30; y : 125),  //I
              (x :  70; y :  95),  //J
              (x :  70; y : 115),  //K
              (x : 100; y : 105),  //L
              (x : 100; y : 125),  //M
              (x : 145; y :  65),  //N
              (x : 165; y :  80),  //P
              (x : 150; y :  80),  //Q
              (x : 135; y :  55 ), //R
              (x : 130; y :  35),  //S
              (x : 145; y :  55),  //T
              (x : 145; y :  35),  //U
              (x : 120; y :  55),  //V
              (x : 120; y :  75),  //W
              (x : 135; y :  75),  //X
              (x : 130; y :  55),  //Y
              (x : 170; y :  70),  //Z
              (x : 140; y :  85),  //AA
              (x : 140; y :  95),  //AB
              (x : 145; y :  85),  //AC
              (x : 145; y :  95),  //AD
              (x : 150; y :  85),  //AE
              (x : 150; y :  95),  //AF
              (x :  50; y : 120),  //BA
              (x : 155; y :  70),  //BB
              (x : 128; y :  70),  //BC
              (x :  20; y :  90),  //tail
              (x :  10; Y :  70)); //tail

     roqdata : array[1..21] of TgPoint =
             ((x:  8; y:  1),
              (x: 28; y:  1),
              (x: 24; y:  3),
              (x:  6; y:  3),
              (x:  5; y: 12),
              (x: 23; y: 14),
              (x: 27; y: 13),
              (x:  6; y: 22),
              (x: 24; y: 21),
              (x: 28; y: 19),
              (x:  4; y: 33),
              (x: 25; y: 35),
              (x: 27; y: 34),
              (x:  4; y: 44),
              (x: 24; y: 44),
              (x: 28; y: 43),
              (x: 13; y:  5),
              (x: 14; y: 15),
              (x: 11; y: 24),
              (x: 17; y: 36),
              (x: 10; y: 45));

      colortable : array[1..5] of DWORD =
                   ($5050a0,$b0b0e0,$506080,$8080c0,$808080);
                  //goat1.......... goat2
                  
      roqplanes : array[1..13] of Troqplane =
              ((x: 16; y:  2; color: $50b050),
               (x: 10; y:  7; color: $9090b0),
               (x: 20; y:  7; color: $8080a0),
               (x: 10; y: 16; color: $5080c0),
               (x: 20; y: 16; color: $4070a0),
               (x: 10; y: 26; color: $7080a0),
               (x: 20; y: 26; color: $506070),
               (x: 10; y: 38; color: $808090),
               (x: 20; y: 38; color: $606060),
               (x: 26; y:  7; color: $303030),
               (x: 26; y: 16; color: $202060),
               (x: 26; y: 26; color: $404040),
               (x: 26; y: 40; color: $404080));

      roqY : array[1..9] of byte = (240,220,210,240,200,190,200,230,220);

      map1blue : array[1..18] of TPoint =
                ((x:  0; y:100),
                 (x: 50; y:125),
                 (x:150; y: 50),
                 (x:200; y:100),
                 (x:225; y: 75),
                 (x:250; y:125),
                 (x:350; y: 75),
                 (x:425; y:100),
                 (x:500; y: 75),
                 (x:575; y:125),
                 (x:625; y: 50),
                 (x:675; y:100),
                 (x:725; y: 25),
                 (x:790;y : 75),
                 (x:825; y:125),
                 (x:875; y:140),
                 (x:900; y: 50),
                 (x:940; y:110));
     focusblue : Tpoint = (x:450;y:25);
     bluecolor = $ff7000;

     map1white : array[1..5] of TPoint =
                ((x:  0; y:200),
                 (x:300; y:150),
                 (x:400; y:200),
                 (x:650; y:130),
                 (x:940; y:200));
     focuswhite : TPoint = (x:450; Y:150);
     whitecolor = $fff0f0;

     focusgrey : TPoint = (x:100; y:225);
     focusbrown: TPoint = (x:235; y:398);
     greycolor = $b0b0b0;
     browncolor = $6078a0;
     focusblack : TPoint = (x:235; y:300);
     blackcolor = $434343;

var map180 : TXbitmap;
    map80 : TXbitmap;
    roq300 : TXbitmap;
    newgoatdata : Tgoat;
    xgoat : Tgoat;

    color1 : DWORD;
    color2 : DWORD;
    reflection : boolean = false;

//--- debug ---

procedure testdraw;
var i : byte;
begin
 with form1.paintbox1.Canvas do
  begin
   for i := 1 to 9 do draw(20+(i-1)*100,roqY[i],roq);
   for i := 1 to 6 do draw(100*(i-1)+35,roqY[i]-70,goatmap[i]);
  end;
end;

//-----

function getRoqY(n : byte) : integer;
//supply y coord of top of roq
begin
 result := roqY[n];
end; 

//--- low level goat drawing ---

procedure line(p1,p2 : byte);
begin
 map180.Xline(newgoatdata[p1].x,newgoatdata[p1].y,newgoatdata[p2].x,
                             newgoatdata[p2].y);
end;

procedure dot(p1 : byte);
begin
 map180.Xdot(newgoatdata[p1].x,newgoatdata[p1].y);
end;

procedure circle(p1,p2 : byte);
var xm,ym,r : single;
    dx,dy : single;
    x1,y1,x2,y2 : byte;
begin
 xm := (newgoatdata[p1].x + newgoatdata[p2].x) / 2;
 ym := (newgoatdata[p1].y + newgoatdata[p2].y) / 2;
 dx := (newgoatdata[p1].x - newgoatdata[p2].x) / 2;
 dy := (newgoatdata[p1].y - newgoatdata[p2].y) / 2;
 r := sqrt(dx*dx + dy*dy);
 x1 := trunc(xm - r + 0.5);
 y1 := trunc(ym - r + 0.5);
 x2 := trunc(xm + r + 0.5);
 y2 := trunc(ym + r + 0.5);
 map180.xellipse(x1,y1,x2,y2);
end;

procedure arc(p1,p2 : byte);
var xm,ym,r : single;
    dx,dy : single;
    x1,y1,x2,y2 : byte;
    s,t : Tgpoint;
begin
 xm := (newgoatdata[p1].x + newgoatdata[p2].x) / 2;
 ym := (newgoatdata[p1].y + newgoatdata[p2].y) / 2;
 dx := (newgoatdata[p1].x - newgoatdata[p2].x) / 2;
 dy := (newgoatdata[p1].y - newgoatdata[p2].y) / 2;
 r := sqrt(dx*dx + dy*dy);
 x1 := trunc(xm - r + 0.5);
 y1 := trunc(ym - r + 0.5);
 x2 := trunc(xm + r + 0.5);
 y2 := trunc(ym + r + 0.5);
 if reflection then
  begin
   s := newgoatdata[p2];
   t := newgoatdata[p1];
  end
  else begin
        s := newgoatdata[p1];
        t := newgoatdata[p2];
       end;
 map180.xarc(x1,y1,x2,y2,s.x,s.y,t.x,t.y);
end;

procedure floodfill(p1 : byte);
begin
 map180.xfloodfill(newgoatdata[p1].x,newgoatdata[p1].y);
end;

//-----------------

procedure colorfix(bm : TXbitmap; color : DWORD);
//adjust colors near color for transparency
type PDW = ^DWORD;
var p0,p1,base,clr : DWORD;
    r,g,b,rr,gg,bb,step : integer;
    i,j : byte;
begin
 color := swapcolor(color);
 base := DWORD(bm.ScanLine[0]);
 step := base - DWORD(bm.scanline[1]);
 bb := color and $ff;
 gg := (color shr 8) and $ff;
 rr := (color shr 16) and $ff;
 for j := 0 to bm.height-1 do
  begin
   p0 := base - j*step;
   for i := 0 to bm.width-1 do
    begin
     p1 := p0 + i*4;
     clr := PDW(p1)^;
     r := (clr shr 16) and $ff;
     g := (clr shr 8) and $ff;
     b := clr and $ff;
     if (abs(r - rr) < 2) and (abs(g - gg) < 2) and (abs(b - bb) < 2) then
         PDW(p1)^ := color;
    end;
  end;
end;

//--- draw goat ---

procedure makeNewGoat;
//draw newgoat in bitmap map
var r180,r80 : Trect;
begin
 with map180 do
  begin
   canvas.Brush.color := $ffffff;
   canvas.FillRect(rect(0,0,width,height));
   xpenlevel := 0;
   xbrushlevel := 1;
   xpenwidth := 5;
   xpencolor := color1;
   line(1,2);
   line(2,3);
   line(3,4);
   line(3,7);
   line(6,7);
   line(3,5);
   xpencolor := colortable[5];
   line(17,18);
   line(19,20);
   xpenwidth := 1;
   xpencolor := color1;
   line(21,22);
   line(22,23);
   line(23,24);
   xpenwidth := 2;
   xpencolor := color1;
   xbrushcolor := color2;
   xusebrush := true;
   circle(8,9);
   circle(10,11);
   circle(12,13);
   xpenwidth := 5;
   arc(4,1);
   arc(5,6);
   xpenwidth := 5;
   xpencolor := $000000;
   dot(25);
   xpenwidth := 10;
   dot(14);
   xpencolor := color1;
   line(35,36);//tail
   xpenwidth := 3;
   xpencolor := color1;
   line(26,27);
   line(28,29);
   line(30,31);
   xpenwidth := 5;
   xpencolor := color2;
   line(15,16);
   xfillstyle := 15;
   xbrushcolor := color1;
   floodfill(32);
   floodfill(33);
   xbrushcolor := color2;
   floodfill(34);
  end;
 with r180 do
  begin
   left := 0; right := 180;
   top := 0; bottom := 180;
  end;
 with r80 do
  begin
   left := 0; right := 80;
   top :=0; bottom := 80;
  end;
 map80.XstretchRect(r80,map180,r180);
 colorfix(map80,$ffffff);
end;

//--- goat data manipulation ---

procedure copygoat(var d : Tgoat; const s : Tgoat);
var i : byte;
begin
 for i := 1 to 36 do
  begin
   d[i].x := s[i].x;
   d[i].y := s[i].y;
  end;
end;

procedure rotateGoat(var d : Tgoat; const s : Tgoat; angle : shortInt);
//positive angle rotates clockwise
var x,y : integer;
    sinA,cosA : single;
    i : byte;
begin
 sinA := sin(angle/180*pi);
 cosa := cos(angle/180*pi);
 for i := 1 to 36 do
  begin
   x := s[i].x - 90;
   y := s[i].y - 90;
   d[i].x := trunc(cosA*x - sinA*y + 90.5);
   d[i].y := trunc(sinA*x + cosA*y + 90.5);
  end;
end;

procedure reflectgoat(var d : Tgoat; const s : Tgoat);
var i : byte;
begin
 for i := 1 to 36 do
  begin
   d[i].x := 179 - s[i].x;
   d[i].y := s[i].y;
  end;
end;

//--- draw all goats ---

procedure makeAllGoats;
var i,j : byte;
begin
 map180 := TXbitmap.Create;  //create goat bitmaps
 with map180 do
  begin
   width := 180;
   height := 180;
  end;
 map80 := TXbitmap.Create;
 with map80 do
  begin
   width := 80;
   height := 80;
  end;

 for i := 1 to 6 do
  begin
   case i of
    1 : begin                     //right, horizontal
         reflection := false;
         color1 := colortable[1];
         color2 := colortable[2];
         copygoat(newgoatdata,goatdata);
        end;
    2 : begin                    //right up
         rotateGoat(newgoatdata, goatdata,-30);
        end;
    3 : begin
         rotateGoat(newgoatdata,goatdata,30);
        end;
    4 : begin
         color1 := colortable[3];
         color2 := colortable[4];
         reflection := true;
         reflectgoat(xgoat,goatdata);
         copygoat(newgoatdata,xgoat);
        end;
    5 : begin
         rotateGoat(newgoatdata,xgoat,-30);
        end;
    6 : begin
         rotateGoat(newgoatdata,xgoat,30);
        end;          
   end;//case
   makeNewGoat;  //newgoatData to map180 , map80
   goatmap[i].Canvas.Draw(0,0,map80);
   goatmap[i].Transparent := true;
   goatmap[i].TransparentColor := $ffffff;
  end;//for i

 map180.free;
 map180 := nil;
 map80.free;
 map80 := nil;
end;

//--- low level roq drawing ---

procedure roqline(a,b : byte);
var x1,y1,x2,y2 : word;
begin
 x1 := roqdata[a].x * 10;
 y1 := roqdata[a].y * 10;
 x2:= roqdata[b].x * 10;
 y2 := roqdata[b].y * 10;
 roq300.Xline(x1,y1,x2,y2);
end;

procedure roqplane(n : byte);
var x,y : word;
begin
 x := roqplanes[n].x * 10;
 y := roqplanes[n].y * 10;
 with roq300 do
  begin
   xbrushcolor := roqplanes[n].color;
   xfloodfill(x,y);
  end;
end;

//--- make roq ---

procedure makeroq;
var i : byte;
    rd,rs : Trect;
begin
 roq300 := TXbitmap.create;
 with roq300 do
  begin
   width := 300;
   height := 450;
  end;
 with roq300 do
  begin
   canvas.Brush.color := $030303;
   xbrushlevel := 1;
   canvas.FillRect(rect(0,0,width,height));
   xpencolor := $000060;
   xpenwidth := 3;
   xpenlevel := 0;
   roqline(1,2);
   roqline(3,17);
   roqline(4,17);
   roqline(5,18);
   roqline(6,18);
   roqline(6,7);
   roqline(8,19);
   roqline(9,19);
   roqline(9,10);
   roqline(11,20);
   roqline(12,20);
   roqline(12,13);
   roqline(14,21);
   roqline(15,21);
   roqline(15,16);
   roqline(1,4);
   roqline(4,5);
   roqline(5,8);
   roqline(8,11);
   roqline(11,14);
   roqline(15,12);
   roqline(12,9);
   roqline(9,6);
   roqline(6,3);
   roqline(3,2);
   roqline(2,7);
   roqline(7,10);
   roqline(10,13);
   roqline(13,16);
   roqline(17,18);
   roqline(18,19);
   roqline(19,20);
   roqline(20,21);
   xfillstyle := 15;
   for i := 1 to 13 do roqplane(i);
  end;

  rd.left := 0; rd.right := roq.width;
  rd.top := 0; rd.bottom := roq.height;
  rs.left := 0; rs.right := roq300.width;
  rs.top := 0; rs.bottom := roq300.height;

  roq.xstretchrect(rd, roq300, rs);
  roq.TransparentColor := $030303;
  roq.Transparent := true;

  roq300.free;
  roq300 := nil;
end;

//--- make map1 ---

procedure makemap1;
const r3 = 3.3333;
var i,j : byte;
    x1,y1,x2,y2 : integer;
    xbias,ybias : integer;
begin
 with map1 do
  begin
   canvas.Brush.color := $ffffff;
   canvas.FillRect(rect(0,0,width,height));
   xusebrush := true;
   xbrushcolor := bluecolor;
   xpencolor := $f0f0f0;
   xpenlevel := 0;
   xbrushlevel := 1;
   xfillstyle := 15;
   xpenwidth := 1;
   for i := 1 to 17 do xline(map1blue[i].x, map1blue[i].y,
                             map1blue[i+1].x, map1blue[i+1].y);
   xfloodfill(focusblue.X,focusblue.Y);
   for i := 1 to 4 do xline(map1white[i].X,map1white[i].Y,
                            map1white[i+1].X,map1white[i+1].Y);
   xbrushcolor := whitecolor;
   xfloodfill(focuswhite.X,focuswhite.Y);
   xpencolor := $000000;
   x1 := 0;
   y1 := 400;
   for i := 1 to 9 do
    begin
     xbias := 20 + (i-1)*100;
     ybias := roqY[i];
     for j := 1 to 4 do
      begin
       case j of
        1 : begin
             x2 := xbias + trunc(roqdata[14].x*r3);
             y2 := ybias + trunc(roqdata[14].y*r3);
            end;
        2 : begin
             x2 := xbias + trunc(roqdata[21].x*r3);
             y2 := ybias + trunc(roqdata[21].y*r3);
            end;
        3 : begin
             x2 := xbias + trunc(roqdata[15].x*r3);
             y2 := ybias + trunc(roqdata[15].y*r3);
            end;
        4 : begin
             x2 := xbias + trunc(roqdata[16].x*r3);
             y2 := ybias + trunc(roqdata[16].y*r3);
            end;
       end;//case
       xline(x1,y1,x2,y2);
       x1 := x2;
       y1 := y2;
      end;//for j
    end;//for i
    x2 := 939;
    y2 := 375;
    xline(x1,y1,x2,y2);

  x1 := 0;
  y1 := 250;
  for i := 1 to 9 do
   begin
    xbias := 20 + (i-1)*100;
    ybias := roqY[i];
    for j := 1 to 2 do
     begin
      case j of
       1 : begin
            x2 := xbias + trunc(roqdata[1].x*r3);
            y2 := ybias + trunc(roqdata[1].y*r3);
           end;
       2 : begin
            x2 := xbias + trunc(roqdata[2].x*r3);
            y2 := ybias + trunc(roqdata[2].y*r3);
           end;
      end;//case
      xline(x1,y1,x2,y2);
       x1 := x2;
       y1 := y2;
     end;//for j
   end;//for i
   x2 := 939;
   y2 := 235;
   xline(x1,y1,x2,y2);
   xbrushcolor := greycolor;
   xfloodfill(focusgrey.X,focusgrey.y);
   xbrushcolor := browncolor;
   xfloodfill(focusbrown.X,focusbrown.y);
   xbrushcolor := blackcolor;
   xfloodfill(focusblack.X,focusblack.Y);
  end;//with map1
end;

end.
